// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_general_purpose_radar_msgs:msg/TargetA.idl
// generated code does not contain a copyright notice
#include "off_highway_general_purpose_radar_msgs/msg/detail/target_a__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
off_highway_general_purpose_radar_msgs__msg__TargetA__init(off_highway_general_purpose_radar_msgs__msg__TargetA * msg)
{
  if (!msg) {
    return false;
  }
  // can_id
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    off_highway_general_purpose_radar_msgs__msg__TargetA__fini(msg);
    return false;
  }
  // id
  // radial_distance
  // radial_velocity
  // reflected_power
  // azimuth_angle
  // measured
  return true;
}

void
off_highway_general_purpose_radar_msgs__msg__TargetA__fini(off_highway_general_purpose_radar_msgs__msg__TargetA * msg)
{
  if (!msg) {
    return;
  }
  // can_id
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // id
  // radial_distance
  // radial_velocity
  // reflected_power
  // azimuth_angle
  // measured
}

bool
off_highway_general_purpose_radar_msgs__msg__TargetA__are_equal(const off_highway_general_purpose_radar_msgs__msg__TargetA * lhs, const off_highway_general_purpose_radar_msgs__msg__TargetA * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // can_id
  if (lhs->can_id != rhs->can_id) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // radial_distance
  if (lhs->radial_distance != rhs->radial_distance) {
    return false;
  }
  // radial_velocity
  if (lhs->radial_velocity != rhs->radial_velocity) {
    return false;
  }
  // reflected_power
  if (lhs->reflected_power != rhs->reflected_power) {
    return false;
  }
  // azimuth_angle
  if (lhs->azimuth_angle != rhs->azimuth_angle) {
    return false;
  }
  // measured
  if (lhs->measured != rhs->measured) {
    return false;
  }
  return true;
}

bool
off_highway_general_purpose_radar_msgs__msg__TargetA__copy(
  const off_highway_general_purpose_radar_msgs__msg__TargetA * input,
  off_highway_general_purpose_radar_msgs__msg__TargetA * output)
{
  if (!input || !output) {
    return false;
  }
  // can_id
  output->can_id = input->can_id;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // radial_distance
  output->radial_distance = input->radial_distance;
  // radial_velocity
  output->radial_velocity = input->radial_velocity;
  // reflected_power
  output->reflected_power = input->reflected_power;
  // azimuth_angle
  output->azimuth_angle = input->azimuth_angle;
  // measured
  output->measured = input->measured;
  return true;
}

off_highway_general_purpose_radar_msgs__msg__TargetA *
off_highway_general_purpose_radar_msgs__msg__TargetA__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_general_purpose_radar_msgs__msg__TargetA * msg = (off_highway_general_purpose_radar_msgs__msg__TargetA *)allocator.allocate(sizeof(off_highway_general_purpose_radar_msgs__msg__TargetA), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_general_purpose_radar_msgs__msg__TargetA));
  bool success = off_highway_general_purpose_radar_msgs__msg__TargetA__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_general_purpose_radar_msgs__msg__TargetA__destroy(off_highway_general_purpose_radar_msgs__msg__TargetA * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_general_purpose_radar_msgs__msg__TargetA__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__init(off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_general_purpose_radar_msgs__msg__TargetA * data = NULL;

  if (size) {
    data = (off_highway_general_purpose_radar_msgs__msg__TargetA *)allocator.zero_allocate(size, sizeof(off_highway_general_purpose_radar_msgs__msg__TargetA), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_general_purpose_radar_msgs__msg__TargetA__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_general_purpose_radar_msgs__msg__TargetA__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__fini(off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_general_purpose_radar_msgs__msg__TargetA__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence *
off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * array = (off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence *)allocator.allocate(sizeof(off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__destroy(off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__are_equal(const off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * lhs, const off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_general_purpose_radar_msgs__msg__TargetA__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence__copy(
  const off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * input,
  off_highway_general_purpose_radar_msgs__msg__TargetA__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_general_purpose_radar_msgs__msg__TargetA);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_general_purpose_radar_msgs__msg__TargetA * data =
      (off_highway_general_purpose_radar_msgs__msg__TargetA *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_general_purpose_radar_msgs__msg__TargetA__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_general_purpose_radar_msgs__msg__TargetA__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_general_purpose_radar_msgs__msg__TargetA__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
